// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::{GraphModel, GraphRenderer};
use glib::{
    prelude::*,
    signal::{connect_raw, SignalHandlerId},
    translate::*,
};
use std::{boxed::Box as Box_, fmt, mem::transmute};

glib::wrapper! {
    #[doc(alias = "DzlGraphView")]
    pub struct GraphView(Object<ffi::DzlGraphView, ffi::DzlGraphViewClass>) @extends gtk::DrawingArea, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_graph_view_get_type(),
    }
}

impl GraphView {
    pub const NONE: Option<&'static GraphView> = None;

    #[doc(alias = "dzl_graph_view_new")]
    pub fn new() -> GraphView {
        assert_initialized_main_thread!();
        unsafe { gtk::Widget::from_glib_none(ffi::dzl_graph_view_new()).unsafe_cast() }
    }
}

impl Default for GraphView {
    fn default() -> Self {
        Self::new()
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::GraphView>> Sealed for T {}
}

pub trait GraphViewExt: IsA<GraphView> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_graph_view_add_renderer")]
    fn add_renderer(&self, renderer: &impl IsA<GraphRenderer>) {
        unsafe {
            ffi::dzl_graph_view_add_renderer(
                self.as_ref().to_glib_none().0,
                renderer.as_ref().to_glib_none().0,
            );
        }
    }

    #[doc(alias = "dzl_graph_view_get_model")]
    #[doc(alias = "get_model")]
    fn model(&self) -> Option<GraphModel> {
        unsafe {
            from_glib_none(ffi::dzl_graph_view_get_model(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_graph_view_set_model")]
    fn set_model(&self, model: &impl IsA<GraphModel>) {
        unsafe {
            ffi::dzl_graph_view_set_model(
                self.as_ref().to_glib_none().0,
                model.as_ref().to_glib_none().0,
            );
        }
    }

    #[doc(alias = "model")]
    fn connect_model_notify<F: Fn(&Self) + 'static>(&self, f: F) -> SignalHandlerId {
        unsafe extern "C" fn notify_model_trampoline<P: IsA<GraphView>, F: Fn(&P) + 'static>(
            this: *mut ffi::DzlGraphView,
            _param_spec: glib::ffi::gpointer,
            f: glib::ffi::gpointer,
        ) {
            let f: &F = &*(f as *const F);
            f(GraphView::from_glib_borrow(this).unsafe_cast_ref())
        }
        unsafe {
            let f: Box_<F> = Box_::new(f);
            connect_raw(
                self.as_ptr() as *mut _,
                b"notify::model\0".as_ptr() as *const _,
                Some(transmute::<_, unsafe extern "C" fn()>(
                    notify_model_trampoline::<Self, F> as *const (),
                )),
                Box_::into_raw(f),
            )
        }
    }
}

impl<O: IsA<GraphView>> GraphViewExt for O {}

impl fmt::Display for GraphView {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("GraphView")
    }
}
